<template>
  <v-card class="mx-auto" max-width="1000">
    <v-container fluid>
      <v-row dense>
        <!--Admin token insert section-->
        <!--It stored at localstorage-->
        <v-col cols="6" justify="center" align="center">
          <v-row dense>
            <v-col cols="12" justify="center" align="center">
              <v-hover v-slot:default="{ hover }" close-delay="200">
                <v-card :elevation="hover ? 20 : 2">
                  <v-list-item three-line>
                    <v-list-item-content>
                      <v-list-item-title align="center" class="headline mb-1"
                        >Admin token</v-list-item-title
                      >
                      <v-form ref="adminTokenForm">
                        <v-text-field
                          :rules="adminTokenRule"
                          label="Please insert admin token"
                          prepend-icon="lock"
                          v-model="adminToken"
                          :append-icon="
                            showAdminToken ? 'mdi-eye' : 'mdi-eye-off'
                          "
                          :type="showAdminToken ? 'text' : 'password'"
                          @click:append="showAdminToken = !showAdminToken"
                          :disabled="saveAdminTokenState"
                          @click="
                            if (errorTrigger) {
                              errorTrigger = false;
                            }
                          "
                        />
                      </v-form>
                    </v-list-item-content>
                  </v-list-item>
                  <v-card-actions>
                    <v-btn
                      outlined
                      color="green"
                      @click="saveAdminToken"
                      :disabled="saveAdminTokenState"
                    >
                      <v-icon left>done</v-icon>
                      <span>Save</span>
                    </v-btn>

                    <v-btn
                      outlined
                      color="red"
                      @click="deleteAdminToken"
                      :disabled="deleteAdminTokenState"
                    >
                      <v-icon left>delete_forever</v-icon>
                      <span>Delete</span>
                    </v-btn>
                  </v-card-actions>
                </v-card>
              </v-hover>
            </v-col>
            <v-col cols="12" justify="center" align="center">
              <v-hover v-slot:default="{ hover }" close-delay="200">
                <v-card :elevation="hover ? 20 : 2">
                  <v-list-item three-line>
                    <v-list-item-content>
                      <v-list-item-title align="center" class="headline mb-1"
                        >Database functions</v-list-item-title
                      >
                        <v-form ref="databaseFunctions">
                          <v-radio-group mandatory v-model="databaseAction" :disabled="unauthedLock">
                            <v-radio
                              label="Truncate"
                              color="warning"
                              value="600"
                            ></v-radio>
                            <v-radio
                              label="Drop database"
                              color="error"
                              value="666"
                            ></v-radio>
                          </v-radio-group>

                        </v-form>
                    </v-list-item-content>
                  </v-list-item>
                  <v-card-actions>
                    <v-btn
                      outlined
                      color="primary"
                      @click="executeDatabaseFunction"
                      :loading="executeDatabaseFunctionState"
                      :disabled="unauthedLock"
                    >
                      <v-icon left>published_with_changes</v-icon>
                      <span>Execute</span>
                    </v-btn>
                  </v-card-actions>
                </v-card>
              </v-hover>
            </v-col>
          </v-row>
        </v-col>
        <!--End of section-->
        <!--Create new section-->
        <v-col cols="6" justify="center" align="center">
          <v-hover v-slot:default="{ hover }" close-delay="200">
            <v-card :elevation="hover ? 20 : 2">
              <v-list-item three-line>
                <v-list-item-content>
                  <v-list-item-title align="center" class="headline mb-1"
                    >Create new user</v-list-item-title
                  >
                  <v-form ref="newUserForm">
                    <v-text-field
                      :rules="emailRules"
                      label="Email"
                      prepend-icon="email"
                      :disabled="unauthedLock"
                      v-model="newEmail"
                      @click="
                        if (errorTrigger) {
                          errorTrigger = false;
                        }
                      "
                    />

                    <v-text-field
                      label="Username"
                      prepend-icon="account_circle"
                      :disabled="unauthedLock"
                      v-model="newUsername"
                      @click="
                        if (errorTrigger) {
                          errorTrigger = false;
                        }
                      "
                    />
                    <v-text-field
                      :rules="passwordRules"
                      label="Password"
                      prepend-icon="lock"
                      v-model="newPassword"
                      :append-icon="showNewPassword ? 'mdi-eye' : 'mdi-eye-off'"
                      :type="showNewPassword ? 'text' : 'password'"
                      :disabled="unauthedLock"
                      @click:append="showNewPassword = !showNewPassword"
                      @click="
                        if (errorTrigger) {
                          errorTrigger = false;
                        }
                      "
                    />
                    <v-text-field
                      label="Country"
                      prepend-icon="map"
                      :disabled="unauthedLock"
                      v-model="newCountry"
                      @click="
                        if (errorTrigger) {
                          errorTrigger = false;
                        }
                      "
                    />
                  </v-form>
                </v-list-item-content>
              </v-list-item>
              <v-card-actions>
                <v-btn
                  outlined
                  color="green"
                  @click="createNewUser"
                  :loading="createNewUserState"
                  :disabled="unauthedLock"
                >
                  <v-icon left>done</v-icon>
                  <span>Create</span>
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-hover>
        </v-col>
        <!--End of section-->
        <!--Get all user-->
        <v-col col="6" justify="center" align="center">
          <v-hover v-slot:default="{ hover }" close-delay="200">
            <v-card :elevation="hover ? 20 : 2">
              <v-list-item three-line>
                <v-list-item-content>
                  <v-list-item-title align="center" class="headline mb-1"
                    >Users</v-list-item-title
                  >
                  <v-data-table
                    v-model="userSelected"
                    :headers="tableHeader"
                    :items="users"
                    :items-per-page="10"
                    show-select
                    single-select
                    class="elevation-1"
                  ></v-data-table>
                </v-list-item-content>
              </v-list-item>

              <v-card-actions>
                <v-btn
                  outlined
                  color="green"
                  @click="getAllUser"
                  :loading="getAllUserLoading"
                  :disabled="unauthedLock"
                >
                  <v-icon left>youtube_searched_for</v-icon>
                  <span>Refresh</span>
                </v-btn>

                <v-btn
                  outlined
                  color="red"
                  @click="deleteUser"
                  :loading="getAllUserLoading"
                  :disabled="unauthedLock"
                >
                  <v-icon left>delete_forever</v-icon>
                  <span>Delete </span>
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-hover>
        </v-col>
        <!--End of section-->
        <v-col col="6" justify="center" align="center">
          <v-hover v-slot:default="{ hover }" close-delay="200">
            <v-card :elevation="hover ? 20 : 2"> </v-card>
          </v-hover>
        </v-col>
      </v-row>
      <v-snackbar v-model="errorTrigger" right bottom :color="errorColor">
        {{ errorMessage }}
      </v-snackbar>
    </v-container>
  </v-card>
</template>

<script>
const axios = require("axios");
export default {
  data: () => ({
    errorTrigger: false,
    errorMessage: "",
    errorColor: "error",
    showAdminToken: false,
    showNewPassword: false,
    adminToken: "correct horse battery staple",
    adminTokenRule: [(v) => !!v || "Kötelező a jelszó megadása!"],
    emailRules: [
      (v) => !!v || "E-mail cím kötelező!",
      (v) => /.+@.+\..+/.test(v) || "Nem érvényes e-mail cím!",
    ],
    passwordRules: [(v) => !!v || "Kötelező a jelszó megadása!"],
    deleteAdminTokenState: true,
    saveAdminTokenState: false,
    createNewUserState: false,
    executeDatabaseFunctionState: false,
    getAllUserLoading: false,
    unauthedLock: true,
    users: [],
    userSelected: [],
    newEmail: null,
    newUsername: null,
    newPassword: null,
    newCountry: null,
    databaseAction: null,
    tableHeader: [
      { text: "Username", value: "username" },
      { text: "ID", value: "id" },
      { text: "Country", value: "country" },
    ],
  }),
  created() {
    this.checkBackend();
    this.checkToken();
  },
  methods: {
    deleteUser(){
      this.getAllUserLoading = true;
      axios({
            method: "delete",
            url: process.env.VUE_APP_API_URL+ "/admin/users",
            headers: {
                Authorization: localStorage.adminToken,
            },
            data: {
              username: this.userSelected[0].username
            }
          })
          .then((response) => {
            if (response.data.status == "ok") {
              this.errorColor = "success"
              this.errorMessage = response.data.msg
              this.errorTrigger = true
            } else{
              this.errorColor = "error"
              this.errorMessage = "Something went wrong!";
              this.errorTrigger = true;
            }
      });
      this.getAllUser();
      this.getAllUserLoading = false;
    },
    executeDatabaseFunction(){
      this.executeDatabaseFunctionState = true;
      switch (this.databaseAction) {
        case "600":
          axios({
            method: "post",
            url: process.env.VUE_APP_API_URL+ "/truncate",
            headers: {
                Authorization: localStorage.adminToken,
            },
          })
          .then((response) => {
            if (response.data.status == "ok") {
              this.errorColor = "success"
              this.errorMessage = response.data.msg
              this.errorTrigger = true
            } else{
              this.errorColor = "error"
              this.errorMessage = "Execute is not working!";
              this.errorTrigger = true;
            }
          });

          break;
      }
      this.executeDatabaseFunctionState = false;
    },
    checkBackend() {
      axios({
        method: "get",
        url: process.env.VUE_APP_API_URL+ "/healthcheck",
      })
        .then((response) => {
          if (response.data.status == "ok") {
            console.log("Backend is available!");
          } else {
            this.errorColor = "error"
            this.errorMessage = "Backend is not reachable!";
            this.errorTrigger = true;
          }
        })
        .catch(() => {
          this.errorColor = "error"
          this.errorMessage = "Backend is not reachable!";
          this.errorTrigger = true;
        });
    },
    checkToken() {
      if (localStorage.adminToken) {
        this.getAllUser();
        this.deleteAdminTokenState = false;
        this.saveAdminTokenState = true;
      }
    },
    saveAdminToken() {
      this.saveAdminTokenState = true;
      localStorage.adminToken = this.adminToken;
      this.adminToken = " correct horse battery staple ";
      this.deleteAdminTokenState = false;
      this.getAllUser();
    },
    deleteAdminToken() {
      this.deleteAdminTokenState = true;

      localStorage.removeItem("adminToken");

      this.saveAdminTokenState = false;
      this.unauthedLock = true;
      this.users = [];
    },
    createNewUser() {
      this.createNewUserState = true;
      if (
        !this.newEmail ||
        !this.newPassword ||
        !this.newUsername ||
        !this.newCountry
      ) {
        this.errorColor = "error"
        this.errorMessage = "Please fill all column";
        this.errorTrigger = true;
      } else {
        axios({
          method: "post",
          url: process.env.VUE_APP_API_URL+ "/admin/users",
          headers: {
            Authorization: localStorage.adminToken,
          },
          data: {
            email: this.newEmail,
            username: this.newUsername,
            password: this.newPassword,
            country: this.newCountry,
          },
        }).then((response) => {
          console.log(response)
          if (response.data.status == "error") {
            this.errorColor = "error"
            this.errorMessage = response.data.msg;
            this.errorTrigger = true;
            if (response.data.msg == "Invalid adminToken!") this.deleteAdminToken();
          } else if (response.data.status == "ok") {

            this.errorColor = "success"
            this.errorMessage = "Successfully created!";
            this.errorTrigger = true;
            this.getAllUser();
            this.$refs.newUserForm.reset();
          }
        });
      }

      this.createNewUserState = false;
    },
    getAllUser() {
      this.getAllUserLoading = true;

      axios({
        method: "get",
        url: process.env.VUE_APP_API_URL+ "/admin/users",
        headers: {
          Authorization: localStorage.adminToken,
        },
      }).then((response) => {
        if (response.data.status == "error") {
          this.errorColor = "error"
          this.errorMessage = response.data.msg;
          this.errorTrigger = true;
          if (response.data.msg == "Invalid adminToken!") this.deleteAdminToken();
        } else if (response.data.status == "ok") {
          if (this.unauthedLock == true) {
            this.errorColor = "success";
            this.errorMessage = "Sucessful login!";
            this.errorTrigger = true;
            this.unauthedLock = false;
          }
          this.users = response.data.payload;
        }
      });

      this.getAllUserLoading = false;
    },
  },
};
</script>